<?php

namespace Teknisa\ACL\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\ACL\Util\InstanceProvider;
use Zeedhi\Framework\DTO;
use Teknisa\ACL\Util\AclUtilities;
use Teknisa\Libs\Util\Environment;

class AclParamgeral extends Crud{

    
    /** @var Teknisa\Libs\Util\Environment */
    protected $environment;

    public function __construct(Manager $manager, Environment $environment) {
        $this->environment = $environment;
        parent::__construct($manager);
    }

    public function findParamgeral(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $request->getFilterCriteria()->getConditions();
        try {
            $paramgeral = InstanceProvider::getService()->getAclParamgeral();
            $paramgeral = $paramgeral->findAclParamgeral();
            $response->addDataSet(new DataSet('aclParamgeral', [$paramgeral]));
        } catch (\Exception $e) {
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
        }
    } 
    
    public function saveParamgeral(Request $request, Response $response) {
        $rows = $request->getDataSet()->getRows()[0];
        $idgeraoper = $rows['IDGERACDOPERADOR'];
        
        try {
            $paramgeral = InstanceProvider::getService()->getAclParamgeral();
            $paramgeral = $paramgeral->saveAclParamgeral($idgeraoper);
            $response->addDataSet(new DataSet('save', [$paramgeral]));
        } catch (\Exception $e) {
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_ERROR));
        }
    }  
    
}